using System;
using System.Drawing;
using P4Lib;

namespace P4Win
{
    public class UserOptions
    {
        public bool computerPlaysFirst = false;
        public Color playerColor = Color.Red;
        public Difficulty diff = Difficulty.Average;

        public override string ToString()
        {
            return String.Format("Difficulty: {0}, Computer Play First: {1}", diff, computerPlaysFirst);
        }
    }
}
